/* main file for house number logger */
/* Copyright (C) 2009 Holger Dietze
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License along
 *   with this program; if not, write to the Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>

#include "events.h"
#include "nmea_reader.h"
#include "lcd.h"
#include "kbd-i2c.h"

int main (void) __attribute__ ((noreturn));

int
main (void)
{
  int x,y;
  nmea_init ();
  lcd_init ();
  kbd_i2c_init ();

  /* switch on all LCD segments */
  for (y=0; y<LCD_PLANES; y++)
    for (x=0; x<LCD_DIGITS; x++)
      lcd_put (y, x, 0b11111111);

  /* LCD display does not work in power-down and standby modes */
  set_sleep_mode (SLEEP_MODE_PWR_SAVE);
  while (1) { /* event loop */
    while (event_queue_cnt) {
      sei ();
      handle_event (0); /* handle first event in queue */
      cli ();
    }
    sleep_enable ();
    sei ();
    sleep_cpu ();
    sleep_disable ();
  }
}
